###---------------------------------------------------------------------
#	  Name: Hidden2Layer.rb
#   Description: Plugins > Hidden to Layer...
#   Author: TIG (c) 2008
#   Usage:  Put this file into the Plugins Folder.
#     To run on just a Selection pick something first...
#     Otherwise it works on the whole of the Model...
#			Pick "Hidden to Layer" off Plugins Menu...
#			Any Hidden Entities are moved to Layer HIDN***
#     Hidden Entities that are inside of Groups or Component 
#     Definitions are moved too, if they are in Selected OR the whole 
#     Model is processed...
#     Remove the # in front of soft/smooth options to include if desired.
#   Version: 
#     1.0	20080314	First issue.
#     1.1  20080314  Also processes soft/smoothed lines,
#                    and all made 'normal' and HIDN 'off'
#     1.2  20080318  Reverted to hidden onto HIDN (off) only
#                    Also mines groups/defs, moves hidden too...
###---------------------------------------------------------------------
require 'sketchup.rb'
###---------------------------------------------------------------------
def hidden2layer
  model=Sketchup.active_model
 ###
 def hidden_miner(ents)
  list=ents
  ents.each{|e|
    elist=[]
  if e.typename=="ComponentInstance" or e.typename=="Group"
	  if e.typename=="ComponentInstance"
      e.definition.entities.each{|c|
        elist.push(c)
 	    }
    end#if
	  if e.typename=="Group"
      e.entities.each{|c|
        elist.push(c)
 	    }
    end#if
	end#if
	  xlist=hidden_miner(elist)
	  list=list+xlist
  }#end each
  return list
 end#def
 ###
  hidn=model.layers.add("HIDN")### ***change layer name here if desired
  model.start_operation("Hidden to Layer")
  if model.selection[0]
    selected=model.selection.to_a
  else
    selected=model.active_entities.to_a
  end#if
  slist=hidden_miner(selected)
  slist.each{|e|
    if e.hidden?
      e.layer=hidn #; e.hidden=false
    end#if
    #if e.typename=="Edge" 
      #if e.soft?
        #e.layer=hidn
        #e.soft=false
      #end#if
      #if e.smooth?
        #e.layer=hidn
        #e.smooth=false
      # end#if
    #end#if
  }
  hidn.visible=false ### this sets layer to 'off'
  model.commit_operation
end#def
### menu bits
if(not file_loaded?("Hidden2Layer.rb"))
  UI.menu("Plugins").add_item("Hidden to Layer"){hidden2layer}
end
file_loaded("Hidden2Layer.rb")
###